unit Form_pdx;

interface

{    Copyright 1995 by TrayMar Software, Inc., all rights reserved.}

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Restruct, Grids, DBGrids, DBCtrls,
  errForm, chgForm, kvform, cmdForm,
  DBLookup, FileCtrl;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button9: TButton;
    Button10: TButton;
    Edit1: TEdit;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Table1: TTable;
    Table1TableName: TStringField;
    Table1Operation: TStringField;
    Table1Name: TStringField;
    Table1arg1: TStringField;
    Table1arg2: TStringField;
    Table1arg3: TStringField;
    Table1arg4: TStringField;
    Table1arg5: TStringField;
    Table1arg6: TStringField;
    Table1arg7: TStringField;
    Table1arg8: TStringField;
    Table1arg9: TStringField;
    Table1arg10: TStringField;
    Table1arg11: TStringField;
    Table1arg12: TStringField;
    Table1arg13: TStringField;
    Table1arg14: TStringField;
    Table1arg15: TStringField;
    Table1arg16: TStringField;
    Table1arg17: TStringField;
    RESTRUCTURE2: TRESTRUCTURE;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    Table2: TTable;
    Table2TableName: TStringField;
    Table2Operation: TStringField;
    Table2Name: TStringField;
    Table2arg1: TStringField;
    Table2arg2: TStringField;
    Table2arg3: TStringField;
    Table2arg4: TStringField;
    Table2arg5: TStringField;
    Table2arg6: TStringField;
    Table2arg7: TStringField;
    Table2arg8: TStringField;
    Table2arg9: TStringField;
    Table2arg10: TStringField;
    Table2arg11: TStringField;
    Table2arg12: TStringField;
    Table2arg13: TStringField;
    Table2arg14: TStringField;
    Table2arg15: TStringField;
    Table2arg16: TStringField;
    Table2arg17: TStringField;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Label1: TLabel;
    Button8: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);

    procedure copyOutTable;
{    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject); }
    procedure Button7Click(Sender: TObject);

{    procedure Button2Click(Sender: TObject);
}
    procedure Button4Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure workDir_LBChange(Sender: TObject);
    procedure privdir_LBChange(Sender: TObject);
    procedure executeRestructure ;
    procedure restructureCommands;
    procedure createCommands;
    procedure filltable;
    procedure Button8Click(Sender: TObject);

  private
    { Private declarations }
    defTable2 : STRING;
  public
    { Public declarations }
    {rstrct : tRestructure;}
    mainDirectory   : String;
    changeTableName : String;
    changeTableDir : String;
    isDemo : Integer;
    privateDirectory : String;
    mainWorkDirectory : String;
    sesPrivateDirectory : String;
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

{$DEFINE DEMO}
{procedure crtACmdTable (Sender : Tobject; aTable, bTable : TTable);
var
   fileCopy : TBatchMove;
   isOpen : longInt;
begin
     isOpen :=1;
     try
          bTable.Open;
     except
          on E: EDBEngineError
              do
                begin
                     isOpen := 0;
                     if E.Errors[0].Errorcode <> 10024
                     then
                         fileCopy.source := atable;
                         fileCopy.destination := bTable;
                         fileCopy.Mode := batCopy;
                         fileCopy.execute;
                 end;
     end;
     if isOpen = 1 then bTable.close;
end;
}
procedure crtACmdTable (Sender : Tobject; aTable, bTable : TTable);
var
   fileCopy : TBatchMove;
begin
     filecopy := TBatchMove.create(form1);
     fileCopy.destination := bTable;
     fileCopy.source := atable;
     fileCopy.Mode := batCopy;
     fileCopy.execute;
end;

procedure deleteATable (Sender : Tobject; aTable : TTable);
begin
     try
          aTable.DeleteTable;
     except
          on E: EDBEngineError
              do
                begin
                     { if found doesn't exist dont worry about error}
                     if E.Errors[0].Errorcode <> 10024
                     then begin
                         showMessage (E.message);
                         end;
                 end;
     end;
     aTable.active := false;
end;
procedure emptyATable (Sender : Tobject; aTable : TTable);
begin
     aTable.active := false;
     try
          aTable.EmptyTable;
     except
          on E: EDBEngineError
              do
                begin
                 showMessage (E.message);
                 end;
     end;
     aTable.active := true;
end;


procedure emptyATable_del (Sender : Tobject; aTable : TTable);
var
   i: longint;
   ok: longint;
begin
     ok := 1;
     try
          aTable.open;
     except
          on E: EDBEngineError
              do
                begin
                 ok := 0;
                 if E.Errors[0].Errorcode <> 10024
                    then begin
                         showMessage (E.message);
                         end;
                 end;
     end;
     if ok = 1
        then begin
             if aTable.EOF <> true
                then begin  
                     for i:= 1 to aTable.RecordCount
                       do
                         aTable.delete;
                     end;
             aTable.refresh;
         end;
end;


procedure Tform1.executeRestructure;
begin
    form3.table1.active := false;
    form3.table1.databaseName := changeTableDir;
    form3.table1.tableName := changeTableName;
    emptyATable_del (self, form3.Table1);
    {form3.table1.active := true;}

    Table1.active := false;
    if isdemo = 1 
       then begin
           restructure2.dorestruct;
           end
       else begin
           restructure2.dorestruct_2(restructure2.cmdTable, restructure2.defTable);

       end;

    table1.active := true;
{enum table}

    session.addPassword(restructure2.defTable);
    table2.active := FALSE;
    emptyATable_del (self, Table2);
    if restructure2.errcode = 0
       then begin
           restructure2.enumstructure_store (restructure2.defTable, 'sampout1.db');
           end;

    table2.active :=TRUE;
    edit1.text := inttostr(restructure2.errcode);
    session.removePassword(restructure2.defTable);
    table2.first;
end;

procedure TForm1.fillTable;
var
   dTable : TTable;
begin
   dTable := TTable.Create (self);
   dTable.Databasename := restructure2.workDir;
   dTable.Tablename    := restructure2.defTable;
   session.addPassword(restructure2.defTable);
   dTable.open;
   dTable.edit;

   if isdemo = 1
      then begin
         dtable.appendRecord(['record 1', '-20']);
         dtable.appendRecord(['record 2', '20']);
         end
     else begin
         dtable.appendRecord(['record 1', '21', '-20']);
         dtable.appendRecord(['record 2', '22', '20']);
     end;

   dtable.close;
   session.removePassword(restructure2.defTable);
end;

procedure Tform1.createCommands;
var
   mTable : TTable;
   dTable : TTable;
   vTable : TTable;
begin
     form2.close;
     form3.close;
     form4.close;
     form5.close;
{ keyviol}
   vTable := TTable.Create (self);
   vTable.Databasename := sesPrivateDirectory;
   vTable.Tablename    := 'keyviol.db';
   form4.table1.active := false;
   deleteATable (self, vTable);
   vTable.close;

   mTable := TTable.Create (self);
   mTable.Databasename := restructure2.workDir;
   mTable.Tablename    := restructure2.cmdTable;

   form5.table1.active := false;
   session.addPassword(restructure2.defTable);
   dTable := TTable.Create (self);
   dTable.Databasename := restructure2.workDir;
   dTable.Tablename    := restructure2.defTable;
   deleteATable (self, dTable);
   session.removePassword(restructure2.defTable);
   dTable.Tablename    := defTable2;
   deleteATable (self, dTable);

   Table1.active := false;
   emptyATable_del (self, mTable);
   Table1.active := true;
   mTable.open;
   mTable.edit;
   if isDemo = 1
      then begin

         mtable.appendRecord(['', 'addField', 'Alpha Field', 'Alpha25']);
         mtable.appendRecord(['', 'addField', 'Number Field', 'Number']);
         mtable.appendRecord(['', 'addValCheck', 'Number Field', 'TRUE', '-100.06', '100.01', '10.6', '[-]#*#']);
         mtable.appendRecord(['', 'addIndexDesc']);
         mtable.appendRecord(['', 'addIndexFields', '', 'Alpha Field', 'Number Field']);
         end
      else begin

         mtable.appendRecord(['', 'addField', 'Alpha Field', 'Alpha25']);
         mtable.appendRecord(['', 'addValCheck', 'Alpha Field', 'FALSE', '', '', 'a']);
         mtable.appendRecord(['', 'addField', 'Number Field', 'Number']);
         mtable.appendRecord(['', 'addValCheck', 'Number Field', 'TRUE', '-100.06', '100.01', '10.6', '[-]#*#']);
         mtable.appendRecord(['', 'addField', 'Money Field', 'Money']);
         mtable.appendRecord(['', 'addValCheck', 'Money Field', '', '-100.06', '100.01', '10.6']);
         mtable.appendRecord(['', 'addField', 'Date Field', 'Date']);
         mtable.appendRecord(['', 'addValCheck', 'Date Field', '', '01/01/1993', '12/01/1998', 'Today']);
         mtable.appendRecord(['', 'addField', 'Short Field', 'Short']);
         mtable.appendRecord(['', 'addValCheck', 'Short Field', '', '-100', '100', '11']);

         mtable.appendRecord(['', 'addField', 'Memo Field', 'Memo']);
         mtable.appendRecord(['', 'addField', 'Time Field', 'Time']);
         mtable.appendRecord(['', 'addValCheck', 'Time Field', '', '00:12;00', '23:12:00', '01:20:00']);

         mtable.appendRecord(['', 'addField', 'TimeStamp Field', 'TimeStamp']);
         mtable.appendRecord(['', 'addValCheck', 'TimeStamp Field', '', '00:12;00, 01/01/1993',
                                            '11:12:00, 12/31/1998', '01:20:00, 12/12/1994']);

         mtable.appendRecord(['', 'addField', 'Long Field', 'Long']);
         mtable.appendRecord(['', 'addValCheck', 'Long Field', '', '-12345', '1234567', '22']);
         mtable.appendRecord(['', 'addField', 'Logical Field', 'Logical']);
         mtable.appendRecord(['', 'addValCheck', 'Logical Field', '', '', '', 'TRUE']);
         mtable.appendRecord(['', 'addIndexDesc']);
         mtable.appendRecord(['', 'addIndexFields', '', 'Alpha Field', 'Number Field']);
         mtable.appendRecord(['', 'addIndexDesc', 'anotherIndex', 'TRUE', 'TRUE']);
         mtable.appendRecord(['', 'addIndexFields', 'anotherIndex', 'Number Field', 'Alpha Field']);
      end;

   mTable.close;
end;

procedure Tform1.restructureCommands;
var
   mTable : TTable;
begin
     form2.close;
     form3.close;
     form4.close;
     form5.close;

   mTable := TTable.Create (self);
   mTable.Databasename := restructure2.workDir;
   mTable.Tablename    := restructure2.cmdTable;

   mTable.open;
   mTable.edit;

   emptyATable_del (self, mTable);

   if isDemo = 1
      then begin
         mtable.appendRecord(['', 'modifyField', 'Alpha Field', '', 'newname Alpha']);
         mtable.appendRecord(['', 'modifyValCheck', 'Number Field', '', '0.0', '', '__drop']);
         mtable.appendRecord(['', 'addField', 'New Field', 'A10', 2]);
         mtable.appendRecord(['', 'modifyIndexFields', '', '1', '2']);
         end
      else begin

         mtable.appendRecord(['', 'modifyField', 'Alpha Field', '', 'newname Alpha']);
         mtable.appendRecord(['', 'modifyValCheck', 'Number Field', '', '0.0', '', '__drop']);
         mtable.appendRecord(['', 'modifyValCheck', 'Money Field', '', '0.0', '', '']);
         {mtable.appendRecord(['', 'modifyValCheck', 'Money Field', '', '0.0', '100.01', '10.6']);}
         mtable.appendRecord(['', 'modifyField', 'Money Field', 'Number', 'was Money now Number']);
         mtable.appendRecord(['', 'addField', 'New Field', 'A10', 2]);
         mtable.appendRecord(['', 'modifyIndexFields', '', '1', '2']);
         mtable.appendRecord(['', 'modifyIndexdesc', 'anotherIndex', '', 'FALSE']);
         mtable.appendRecord(['', 'modifyIndexFields', 'anotherIndex', '2', '3', '1']);
         mtable.appendRecord(['', 'addMaster', restructure2.defTable]);
         mtable.appendRecord(['', 'addPwdDesc', 'sample2', 'full']);
         mtable.appendRecord(['', 'addPwdDesc', 'sample1', 'full']);
         mtable.appendRecord(['', 'addPwdFields', 'sample1', '1', 'full', 'New Field', 'none', '3', 'readonly',
                                                   '4', 'full']);
         mtable.appendRecord(['', 'addPwdFields', 'sample1', '5', 'full', '6', 'none', '7', 'readonly', '8', 'full']);
      end;


  mtable.close;
end;

procedure TForm1.copyOutTable ;
var
   mTable : TTable;
   sTable : TTable;
   fileCopy : TBatchMove;
begin
     mTable := TTable.Create (self);
     sTable := TTABle.Create (self);
     fileCopy := TBatchMove.create (self);

     mTable.Databasename := restructure2.workDir;
     mTable.Tablename    := restructure2.defTable;
   {identify the default table}
     sTable.Databasename := restructure2.workDir;
     sTable.Tablename    := 'sampout1.db';

  {copy the default table into the modstrct.db}
     fileCopy.source := stable;
     fileCopy.destination := mTable;
     fileCopy.Mode := batCopy;
     fileCopy.execute;
     try
          fileCopy.execute;
     except
          on E: EDBEngineError
              do
                begin
                 showMessage (E.message);
                 end;
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   origCmdTable : TTable;
   smpTable     : TTable;

begin
     mainDirectory := 'c:\rstr2.0\rstrct16\rstr_dfi';
     mainWorkDirectory := mainDirectory + '\work';

     restructure2 := Trestructure.create(self);
     isDemo := restructure2.isDemo;

     restructure2.workDir := mainWorkDirectory;
     restructure2.privDir  := mainDirectory + '\priv';
     sesPrivateDirectory := session.privateDir;
     privateDirectory := restructure2.privDir;
      {identify the defTable and cmdTable if not standard}
     if isDemo = 1 
        then begin
            restructure2.defTable := 'temp.db';
            restructure2.cmdtable := 'modstrct.db';
            defTable2 := 'temp.dbf'
        end
        else begin
            restructure2.defTable := 'sample.db';
            restructure2.cmdtable := 'commands.db';
            defTable2 := 'sample.dbf';
        end;


     Button1.hint := 'This button fills ' + restructure2.cmdTable + ' with the create commands for '
                     + restructure2.defTable + ' and then executes the doRestruct procedure and then adds data';
     Button1.showHint := TRUE;

     Button2.hint := 'This button fills ' + restructure2.cmdTable + ' with the create commands for '
                     + restructure2.defTable;
     Button2.showHint := TRUE;                 

     Button4.hint := 'This button fills ' + restructure2.cmdTable + ' with the restructure commands for '
                     + restructure2.defTable + ' and then executes the doRestruct procedure';
     Button4.showHint := TRUE;

     Button5.hint := 'This button fills ' + restructure2.cmdTable + ' with the restructure commands for '
                     + restructure2.defTable;
     Button5.showHint := TRUE;                 

     Button3.hint := 'This button executes the doRestruct procedure on ' + restructure2.cmdTable + ' and '
                     + restructure2.defTable;
     Button3.showHint := TRUE;                 

     Button6.hint := 'This button fills the ' + restructure2.defTable + ' with Data ';
     Button6.showHint := TRUE;

     Button10.hint := 'Show the changes table after executing the restructure';
     Button10.showHint := TRUE;                 

     Button7.hint := 'Show the keyviol table after executing the restructure';
     Button7.showHint := TRUE;

     Button9.hint := 'Show the errors table if an error occurs in any of the procedures';
     Button9.showHint := TRUE;                 

     changeTableDir := privateDirectory;
     changeTableName := 'changes.db';
     if isdemo <> 1
        then begin
             restructure2.rename_chgTable (changeTableDir + '\' + changeTableName);
        end;

     origCmdTable := TTable.Create (self);
     origCmdTable.DatabaseName := mainWorkDirectory;
     origCmdTable.TableName := 'mod_bak.db';

     smpTable := TTable.Create (self);
     smpTable.DatabaseName := mainWorkDirectory;
     smpTable.TableName := restructure2.cmdTable;
     crtACmdTable (self, origCmdTable, smpTable);

     smpTable.DatabaseName := mainWorkDirectory;
     smpTable.TableName := 'sampout1.db';
     crtACmdTable (self, origCmdTable, smpTable);

     Table1.active := False;
     Table1.DatabaseName := mainWorkDirectory;
     Table1.TableName := restructure2.cmdTable;
     emptyATable_del (self, Table1);
     Table1.active := True;

     Table2.active := False;
     Table2.DatabaseName := mainWorkDirectory;
     emptyATable_del (self, Table2);
     Table2.active := True;
     if isdemo = 1 then begin label1.caption := 'Demo Version'; end
                   else begin label1.caption := 'Full Version'; end;
     edit1.text := '';

end;


procedure TForm1.Button1Click(Sender: TObject);
begin

     createCommands;
     Table1.first;
     Table1.refresh;
     executeRestructure;
     filltable;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
     restructureCommands;
     Table1.first;
     Table1.refresh;
     executeRestructure;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin

     restructureCommands;
     Table1.first;
     Table1.refresh;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin

     createCommands;
     Table1.first;
     Table1.refresh;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin

    executeRestructure;
     
end;
procedure TForm1.Button6Click(Sender: TObject);
begin

    fillTable;
     
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  {Call the Restructure Procedure}
    session.addPassword(restructure2.defTable);
    restructure2.enumstructure_print (restructure2.defTable, 'sampout2.txt');

    restructure2.enumstructure_store (restructure2.defTable, 'sampout2.db');
    edit1.text := inttostr(restructure2.errcode);
    session.removePassword(restructure2.defTable);

end;

procedure TForm1.Button9Click(Sender: TObject);
begin
      form2.table1.active := false;
     {form2.table1.databaseName := restructure2.privDir;}
{      form2.table1.databasename := changeTableDir;}
       if isdemo = 1 then begin
              form2.table1.databaseName := privateDirectory; end
              else  begin
              form2.table1.databaseName := privateDirectory;
              end;
       edit1.text := form2.table1.databaseName;
        form2.table1.active := true;
     form2.table1.open;
     form2.show;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
     if length(changeTableDir) > 0
        then begin
              form3.table1.active := false;
              if isdemo = 1 
                 then begin form3.table1.databaseName := privateDirectory; end
                 else begin form3.table1.databaseName := changeTableDir;
                 end;
              form3.table1.tablename := changeTablename;
              form3.table1.active := true;
             end
        else  begin
              form3.table1.active := false;
             form3.table1.databaseName := privateDirectory;
             form3.table1.tablename := 'changes.db';
             edit1.text := form3.table1.databaseName;
             form3.table1.active := true;
             end;

     form3.table1.open;
     {form3.dbgrid1.colwidths[0] := 0.25 *form3.table1.dbgrid1.colwidths[0];}
     form3.show;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
      form4.table1.active := false;
      form4.table1.databaseName := sesPrivateDirectory;
      form4.table1.tablename := 'keyviol.db';
      edit1.text := form4.table1.databaseName;
      form4.table1.active := true;

      form4.table1.open;

     form4.show;
     
end;
procedure TForm1.workDir_LBChange(Sender: TObject);
begin
     {restructure2.workDir := workDir_LB.directory;}

end;

procedure TForm1.privdir_LBChange(Sender: TObject);
begin
     {restructure2.privDir := privDir_LB.directory;}

end;

procedure TForm1.Button8Click(Sender: TObject);
begin
     form5.borderIcons := form5.borderIcons - [biSystemMenu];
       if isdemo = 1 then begin
              form5.table1.databaseName := mainWorkDirectory; end
              else  begin
              ;form5.table1.databaseName := mainWorkDirectory;
              end;
     form5.table1.tableName := restructure2.defTable;
     form5.table1.active := true;
     form5.table1.open;
     form5.show;

end;

end.



















         
