unit Form_dbf;

interface

{    Copyright 1995 by TrayMar Software, Inc., all rights reserved.}

uses
 Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
 DB, DBTables, Grids, DBGrids, StdCtrls,
 errForm, chgForm, kvform, cmdForm, restruct;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button9: TButton;
    Button10: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Label1: TLabel;
    Button8: TButton;
    RESTRUCTURE1: TRESTRUCTURE;
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    DataSource2: TDataSource;
    Table2: TTable;
    DBGrid2: TDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);

    procedure copyOutTable;
{    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject); }
    procedure Button7Click(Sender: TObject);

{    procedure Button2Click(Sender: TObject);
}
    procedure Button4Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure workDir_LBChange(Sender: TObject);
    procedure privdir_LBChange(Sender: TObject);
    procedure executeRestructure ;
    procedure restructureCommands;
    procedure createCommands;
    procedure filltable;
    procedure Button8Click(Sender: TObject);

  private
    { Private declarations }
    defTable2 : STRING;
  public
    { Public declarations }
    {rstrct : tRestructure;}
    mainDirectory   : String;
    changeTableName : String;
    changeTableDir : String;
    isDemo : Integer;
    privateDirectory : String;
    mainWorkDirectory : String;
    sesPrivateDirectory : String;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{$DEFINE DEMO}
{procedure crtACmdTable (Sender : Tobject; aTable, bTable : TTable);
var
   fileCopy : TBatchMove;
   isOpen : longInt;
begin
     isOpen :=1;
     try
          bTable.Open;
     except
          on E: EDBEngineError
              do
                begin
                     isOpen := 0;
                     if E.Errors[0].Errorcode <> 10024
                     then
                         fileCopy.source := atable;
                         fileCopy.destination := bTable;
                         fileCopy.Mode := batCopy;
                         fileCopy.execute;
                 end;
     end;
     if isOpen = 1 then bTable.close;
end;
}
procedure crtACmdTable (Sender : Tobject; aTable, bTable : TTable);
var
   fileCopy : TBatchMove;
begin
     filecopy := TBatchMove.create(form1);
     fileCopy.destination := bTable;
     fileCopy.source := atable;
     fileCopy.Mode := batCopy;
     fileCopy.execute;
end;

procedure deleteATable (Sender : Tobject; aTable : TTable);
begin
     try
          aTable.DeleteTable;
     except
          on E: EDBEngineError
              do
                begin
                     { if found doesn't exist dont worry about error}
                     if E.Errors[0].Errorcode <> 10024
                     then begin
                         showMessage (E.message);
                         end;
                 end;
     end;
     aTable.active := false;
end;

procedure emptyATable (Sender : Tobject; aTable : TTable);
begin
     aTable.active := false;
     try
          aTable.EmptyTable;
     except
          on E: EDBEngineError
              do
                begin
                 showMessage (E.message);
                 end;
     end;
     aTable.active := true;
end;


procedure emptyATable_del (Sender : Tobject; aTable : TTable);
var
   i: longint;
   ok: longint;
begin
     ok := 1;
     try
          aTable.open;
     except
          on E: EDBEngineError
              do
                begin
                 ok := 0;
                 if E.Errors[0].Errorcode <> 10024
                    then begin
                         showMessage (E.message);
                         end;
                 end;
     end;
     if ok = 1
        then begin
             if aTable.EOF <> true
                then begin
                     for i:= 1 to aTable.RecordCount
                       do
                         aTable.delete;
                     end;
             aTable.refresh;
         end;
end;


procedure Tform1.executeRestructure;
begin
    form3.table1.active := false;
    form3.table1.databaseName := changeTableDir;
    form3.table1.tableName := changeTableName;
    emptyATable_del (self, form3.Table1);
    {form3.table1.active := true;}

    Table1.active := false;
    if isdemo = 1 
       then begin
           RESTRUCTURE1.dorestruct;
           end
       else begin
           RESTRUCTURE1.dorestruct_2(RESTRUCTURE1.cmdTable, RESTRUCTURE1.defTable);

       end;

    table1.active := true;
{enum table}

    session.addPassword(defTable2);
    table2.active := FALSE;
    emptyATable_del (self, Table2);
    if RESTRUCTURE1.errcode = 0
       then begin
           RESTRUCTURE1.enumstructure_store (RESTRUCTURE1.defTable, 'sampout1.db');
           end;

    table2.active :=TRUE;
    edit1.text := inttostr(RESTRUCTURE1.errcode);
    session.removePassword(defTable2);
    table2.first;
end;

procedure TForm1.fillTable;
var
   dTable : TTable;
begin
   dTable := TTable.Create (self);
   dTable.Databasename := RESTRUCTURE1.workDir;
   dTable.Tablename    := RESTRUCTURE1.defTable;
   dTable.open;
   dTable.edit;

   if isdemo = 1
      then begin
         dtable.appendRecord(['record 1 01234', '-20']);
         dtable.appendRecord(['record 2 01234567890', '20']);
         end
     else begin
         dtable.appendRecord(['record 1 01234', '21', '-20']);
         dtable.appendRecord(['record 2 01234567890', '22', '20']);
     end;

   dtable.close;
end;

procedure Tform1.createCommands;
var
   mTable : TTable;
   dTable : TTable;
   vTable : TTable;
begin
     form2.close;
     form3.close;
     form4.close;
     form5.close;
{ keyviol}
   vTable := TTable.Create (self);
   vTable.Databasename := sesPrivateDirectory;
   vTable.Tablename    := 'problems.dbf';
   form4.table1.active := false;
   deleteATable (self, vTable);
   vTable.close;

   mTable := TTable.Create (self);
   mTable.Databasename := RESTRUCTURE1.workDir;
   mTable.Tablename    := RESTRUCTURE1.cmdTable;

   form5.table1.active := false;
   dTable := TTable.Create (self);
   dTable.Databasename := RESTRUCTURE1.workDir;
{delete dBase type table}
   dTable.Tablename    := RESTRUCTURE1.defTable;
   deleteATable (self, dTable);
{delete Pdox type table}
   session.addPassword(defTable2);
   dTable.Tablename    := defTable2;
   deleteATable (self, dTable);
   session.removePassword(defTable2);

   Table1.active := false;
   emptyATable_del (self, mTable);
   Table1.active := true;
   mTable.open;
   mTable.edit;
   if isDemo = 1
      then begin
         mTable.appendRecord(['', 'tableType', 'dBase']);
         mtable.appendRecord(['', 'addField', 'AlphaField', 'Alpha25']);
         mtable.appendRecord(['', 'addField', 'NumbField', 'Number10.3']);
         mtable.appendRecord(['', 'addDBFIndexDesc', 'mainIndex', '', 'TRUE']);
         mtable.appendRecord(['', 'addDBFIndexEXPR', 'mainIndex', '', 'AlphaField']);
         end
      else begin
         mTable.appendRecord(['', 'tableType', 'dBase']);
         mtable.appendRecord(['', 'addField', 'AlphaField', 'Alpha25']);
         mtable.appendRecord(['', 'addField', 'A2Field', 'Alpha25']);
         mtable.appendRecord(['', 'addField', 'NumbField', 'Number10.3']);
         mtable.appendRecord(['', 'addField', 'DateField', 'Date']);
         mtable.appendRecord(['', 'addField', 'MemoField', 'Memo']);
         mtable.appendRecord(['', 'addField', 'LogField', 'Logical']);
         mtable.appendRecord(['', 'addDBFIndexDesc', 'mainIndex', '', 'TRUE']);
         mtable.appendRecord(['', 'addDBFIndexEXPR', 'mainIndex', '', 'AlphaField']);
         mtable.appendRecord(['', 'addDBFIndexDesc', 'Index2', '', 'TRUE']);
         mtable.appendRecord(['', 'addDBFIndexEXPR', 'Index2', '', 'A2Field']);
      end;

   mTable.close;
end;

procedure Tform1.restructureCommands;
var
   mTable : TTable;
begin
     form2.close;
     form3.close;
     form4.close;
     form5.close;

   mTable := TTable.Create (self);
   mTable.Databasename := RESTRUCTURE1.workDir;
   mTable.Tablename    := RESTRUCTURE1.cmdTable;

   mTable.open;
   mTable.edit;

   emptyATable_del (self, mTable);

   if isDemo = 1
      then begin
         mtable.appendRecord(['', 'addField', 'newField', 'C20', 2]);
         mtable.appendRecord(['', 'modifyField', 'AlphaField', 'Character15', 'newName']);
         mtable.appendRecord(['', 'moveField', 'numbField', '1']);
         mtable.appendRecord(['', 'modifyDBFIndexDesc', 'mainIndex', '','', 'TRUE', 'TRUE']);
         mtable.appendRecord(['', 'modifyDBFIndexExpr', 'mainIndex', '', 'newName+newField']);
         end
      else begin
         mTable.appendRecord(['', 'nosilentTrim', 'true']);
         mtable.appendRecord(['', 'addField', 'newField', 'C20', 2]);
         mtable.appendRecord(['', 'modifyField', 'AlphaField', 'Character15', 'newName']);
         mtable.appendRecord(['', 'moveField', 'A2Field', '1']);
         mtable.appendRecord(['', 'modifyDBFIndexDesc', 'mainIndex', '','', 'TRUE', 'TRUE']);
         mtable.appendRecord(['', 'modifyDBFIndexExpr', 'Index2', '', 'A2Field+NewField', 'newField > "a"']);
      end;

  mtable.close;
end;

procedure TForm1.copyOutTable ;
var
   mTable : TTable;
   sTable : TTable;
   fileCopy : TBatchMove;
begin
     mTable := TTable.Create (self);
     sTable := TTABle.Create (self);
     fileCopy := TBatchMove.create (self);

     mTable.Databasename := RESTRUCTURE1.workDir;
     mTable.Tablename    := RESTRUCTURE1.defTable;
   {identify the default table}
     sTable.Databasename := RESTRUCTURE1.workDir;
     sTable.Tablename    := 'sampout1.db';

  {copy the default table into the modstrct.db}
     fileCopy.source := stable;
     fileCopy.destination := mTable;
     fileCopy.Mode := batCopy;
     fileCopy.execute;
     try
          fileCopy.execute;
     except
          on E: EDBEngineError
              do
                begin
                 showMessage (E.message);
                 end;
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   origCmdTable : TTable;
   smpTable     : TTable;

begin
     mainDirectory := 'c:\rstr2.0\rstrct32\rstr_dfi';
     mainWorkDirectory := mainDirectory + '\work';

     RESTRUCTURE1 := Trestructure.create(self);
     isDemo := RESTRUCTURE1.isDemo;

     RESTRUCTURE1.workDir := mainWorkDirectory;
     RESTRUCTURE1.privDir  := mainDirectory + '\priv';
     sesPrivateDirectory := session.privateDir;
     privateDirectory := RESTRUCTURE1.privDir;
      {identify the defTable and cmdTable if not standard}
     if isDemo = 1 
        then begin
            RESTRUCTURE1.defTable := 'temp.dbf';
            defTable2 := 'temp.db';
            RESTRUCTURE1.cmdtable := 'modstrct.db';
        end
        else begin
            RESTRUCTURE1.defTable := 'sample.dbf';
            defTable2 := 'sample.db';
            RESTRUCTURE1.cmdtable := 'commands.db';
        end;


     Button1.hint := 'This button fills ' + RESTRUCTURE1.cmdTable + ' with the create commands for \n'
                     + RESTRUCTURE1.defTable + ' and then executes the doRestruct procedure and then adds data';
     Button1.showHint := TRUE;

     Button2.hint := 'This button fills ' + RESTRUCTURE1.cmdTable + ' with the create commands for '
                     + RESTRUCTURE1.defTable;
     Button2.showHint := TRUE;                 

     Button4.hint := 'This button fills ' + RESTRUCTURE1.cmdTable + ' with the restructure commands for '
                     + RESTRUCTURE1.defTable + ' and then executes the doRestruct procedure';
     Button4.showHint := TRUE;                 

     Button5.hint := 'This button fills ' + RESTRUCTURE1.cmdTable + ' with the restructure commands for '
                     + RESTRUCTURE1.defTable;
     Button5.showHint := TRUE;                 

     Button3.hint := 'This button executes the doRestruct procedure on ' + RESTRUCTURE1.cmdTable + ' and '
                     + RESTRUCTURE1.defTable;
     Button3.showHint := TRUE;                 

     Button6.hint := 'This button fills the ' + RESTRUCTURE1.defTable + ' with Data ';
     Button6.showHint := TRUE;

     Button10.hint := 'Show the changes table after executing the restructure';
     Button10.showHint := TRUE;

     Button7.hint := 'Show the keyviol table after executing the restructure';
     Button7.showHint := TRUE;

     Button9.hint := 'Show the errors table if an error occurs in any of the procedures';
     Button9.showHint := TRUE;

     changeTableDir := privateDirectory;
     changeTableName := 'changes.db';
     if isdemo <> 1
        then begin
             RESTRUCTURE1.rename_chgTable (changeTableDir + '\' + changeTableName);
        end;

   {  origCmdTable := TTable.Create (self);
     origCmdTable.DatabaseName := mainWorkDirectory;
     origCmdTable.TableName := 'mod_bak.db';

     smpTable := TTable.Create (self);
     smpTable.DatabaseName := mainWorkDirectory;
     smpTable.TableName := RESTRUCTURE1.cmdTable;
     Table1.active := false;
     crtACmdTable (self, origCmdTable, smpTable);
     Table1.active := true;

     smpTable.DatabaseName := mainWorkDirectory;
     smpTable.TableName := 'sampout1.db';
     Table2.active := false;
     crtACmdTable (self, origCmdTable, smpTable);
     Table2.active := true;
    }

     Table1.active := False;
     Table1.DatabaseName := mainWorkDirectory;
     Table1.TableName := RESTRUCTURE1.cmdTable;
     emptyATable_del (self, Table1);
     Table1.active := True;

     Table2.active := False;
     Table2.DatabaseName := mainWorkDirectory;
     emptyATable_del (self, Table2);
     Table2.active := True;

     if isdemo = 1 then begin label1.caption := 'Demo Version'; end
                   else begin label1.caption := 'Full Version'; end;
     edit1.text := '';

end;


procedure TForm1.Button1Click(Sender: TObject);
begin

     createCommands;
     Table1.first;
     Table1.refresh;
     executeRestructure;
     filltable;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin

     restructureCommands;
     Table1.first;
     Table1.refresh;
     executeRestructure;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin

     restructureCommands;
     Table1.first;
     Table1.refresh;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin

     createCommands;
     Table1.first;
     Table1.refresh;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin

    executeRestructure;
     
end;
procedure TForm1.Button6Click(Sender: TObject);
begin

    fillTable;
     
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  {Call the Restructure Procedure}
    session.addPassword(RESTRUCTURE1.defTable);
    RESTRUCTURE1.enumstructure_print (RESTRUCTURE1.defTable, 'sampout2.txt');

    RESTRUCTURE1.enumstructure_store (RESTRUCTURE1.defTable, 'sampout2.db');
    edit1.text := inttostr(RESTRUCTURE1.errcode);
    session.removePassword(RESTRUCTURE1.defTable);

end;

procedure TForm1.Button9Click(Sender: TObject);
begin
      form2.table1.active := false;
     {form2.table1.databaseName := RESTRUCTURE1.privDir;}
{      form2.table1.databasename := changeTableDir;}
       if isdemo = 1 then begin
              form2.table1.databaseName := privateDirectory; end
              else  begin
              form2.table1.databaseName := privateDirectory;
              end;
       edit1.text := form2.table1.databaseName;
        form2.table1.active := true;
     form2.table1.open;
     form2.show;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
     if length(changeTableDir) > 0
        then begin
              form3.table1.active := false;
              if isdemo = 1 
                 then begin form3.table1.databaseName := privateDirectory; end
                 else begin form3.table1.databaseName := changeTableDir;
                 end;
              form3.table1.tablename := changeTablename;
              form3.table1.active := true;
             end
        else  begin
              form3.table1.active := false;
             form3.table1.databaseName := privateDirectory;
             form3.table1.tablename := 'changes.db';
             edit1.text := form3.table1.databaseName;
             form3.table1.active := true;
             end;

     form3.table1.open;
     {form3.dbgrid1.colwidths[0] := 0.25 *form3.table1.dbgrid1.colwidths[0];}
     form3.show;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
      form4.table1.active := false;
      form4.table1.databaseName := sesPrivateDirectory;
      form4.table1.tablename := 'problems.dbf';
      edit1.text := form4.table1.databaseName;
      form4.table1.active := true;

      form4.table1.open;
      
     form4.show;
     
end;
procedure TForm1.workDir_LBChange(Sender: TObject);
begin
     {RESTRUCTURE1.workDir := workDir_LB.directory;}

end;

procedure TForm1.privdir_LBChange(Sender: TObject);
begin
     {RESTRUCTURE1.privDir := privDir_LB.directory;}

end;

procedure TForm1.Button8Click(Sender: TObject);
begin
     form5.borderIcons := form5.borderIcons - [biSystemMenu];
       if isdemo = 1 then begin
              form5.table1.databaseName := mainWorkDirectory; end
              else  begin
              ;form5.table1.databaseName := mainWorkDirectory;
              end;
     form5.table1.tableName := RESTRUCTURE1.defTable;
     form5.table1.active := true;
     form5.table1.open;
     form5.show;

end;

end.



















         
